=== debian/changelog ===
tdlib (1.7.9~chris1) impish; urgency=medium

  * Split off from telegram bot api

 -- Chris <dpkg@chris-nz.com>  Tue, 30 Nov 2021 01:17:59 +1300

telegram-bot-api (1.7.4-6) groovy; urgency=medium

  * add missing static libs for tdnet and tdutils

 -- Chris <dpkg@chris-nz.com>  Sun, 06 Jun 2021 22:03:35 +1200

telegram-bot-api (1.7.4-5) groovy; urgency=medium

  * stricter permissions on the conf file, improve binlog_dump manpage

 -- Chris <dpkg@chris-nz.com>  Sun, 06 Jun 2021 14:44:10 +1200

telegram-bot-api (1.7.4-4) groovy; urgency=medium

  * Add missing conf file 

 -- Chris <dpkg@chris-nz.com>  Fri, 04 Jun 2021 21:21:29 +1200

telegram-bot-api (1.7.4-3) groovy; urgency=medium

  * Update group for api server user

 -- Chris <dpkg@chris-nz.com>  Fri, 04 Jun 2021 20:40:09 +1200

telegram-bot-api (1.7.4-2) groovy; urgency=medium

  * Version bump because of problems with submodule

 -- Chris <dpkg@chris-nz.com>  Fri, 04 Jun 2021 19:36:11 +1200

telegram-bot-api (1.7.4-1) groovy; urgency=medium

  * Initial release.

 -- Chris <dpkg@chris-nz.com>  Tue, 01 Jun 2021 10:57:28 +1200
