=== debian/control ===
Source: tdlib
Maintainer: Chris <dpkg@chris-nz.com>
Section: misc
Priority: optional
Standards-Version: 4.5.1
Homepage: https://github.com/tdlib/td
Build-Depends: debhelper (>=9), zlib1g-dev, libssl-dev, gperf, cmake, git

Package: libtd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: tdlib
Description: Cross-platform Telegram client library - runtime
 TDLib (Telegram Database library) is a cross-platform library for
 building Telegram clients.
 It can be easily used from almost any programming language.
 .
 This package contains the runtime library files needed to build software
 using TDLib.

Package: libtdjson
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cross-platform Telegram client library - runtime
 TDLib (Telegram Database library) is a cross-platform library for
 building Telegram clients.
 It can be easily used from almost any programming language.
 .
 This package contains the runtime library files needed to run software
 using TDLib through the JSON interface

Package: libtdjson-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libtdjson (= ${binary:Version})
Description: Cross-platform Telegram client library - development files
 TDLib (Telegram Database library) is a cross-platform library for
 building Telegram clients.
 It can be easily used from almost any programming language.
 .
 This package contains the files for building software using tdlib through
 its JSON interface.
